Subject: Re: Sergey's latest cygwin.dll and pdksh
From: [email-masked] (Chris Faylor)

17 Jun 1997 20:33:12 -0700
Approved: [email-masked]
Distribution: cygnus
Message-ID: <[email-masked]>
References: <[email-masked]>
Reply-To: [email-masked]
X-Newsreader: trn 4.0-test57 (27 Apr 97)
Original-To: [email-masked]
X-Mailer: Perl5 Mail::Internet v1.28
Original-Sender: [email-masked]

In article <[email-masked]>,
Sergey Okhapkin  <[email-masked]> wrote:
>Chris Faylor wrote:
>>
>> #ifdef POSIX_SIGNALS
>>     struct sigaction act;
>>
>>     act.sa_handler = (SIGNAL_HANDTYPE) handler;
>>     sigemptyset(&act.sa_mask);        /* only block sig while in handler 
>*/
>>     act.sa_flags = 0;
>> # ifdef SA_INTERRUPT                  /* SunOS 4.x */
>>     if (interact)
>>         act.sa_flags |= SA_INTERRUPT; /* make sure system calls are not 
>restarte
>> d */
>> # endif
>>     sigaction(sig, &act, (struct sigaction *)NULL);
>>
>> ----
>>
>> Where the 'sig' is 'SIGCHLD'.
>>
>> It appears that 'sig' is blocked while within the handler.  Could that be
>> what is going wrong?
>
>Cygwin.dll blocks the signal while executing signal's handler. If arrived 
>signal is blocked, it will be added to process's sig_pending mask. On exit 
>from any handler all pending signals are raised again. See exceptions.cc 
>for details. Probably, we have to change sig_pending from a bit mask to an 
>array of counters to avoid possible losts of a signals. What do you think 
>about?

That sounds right to me.  Otherwise you lose multiple arrival of signals.

I did take the time to debug this yesterday, and I am mystified as to why
it is failing.  When I set a breakpoint on the signal handler, it is
hit every time a subprocess dies, and 'zsh' continues on as it should.
When I remove the breakpoint zsh 'hangs' waiting for SIGCHLD.  Weird.
-- 
http://www.bbc.com/	[email-masked]			"Strange how unreal
VMS=>UNIX Solutions	Boston Business Computing	 the real can be."
-
For help on using this list (especially unsubscribing), send a message to
"[email-masked]" with one line of text: "help".